#include <LiquidCrystal.h>

#if defined (ARDUINO_ARCH_ESP8266)
// esp8266 Lolin/Wemos D1 R1 (uno form factor)
const int rs=D8, en=D9, db4=D4, db5=D5, db6=D6, db7=D7;
#elif defined(ARDUINO_ARCH_ESP32)
// esp32 espduino32 D1 R32 (uno form factor)
// note: GPIO12 needs a pulldown resistor
const int rs=12, en=13, db4=17, db5=16, db6=27, db7=14;
#else
const int rs=8, en=9, db4=4, db5=5, db6=6, db7=7;       // for all other devices
#endif
LiquidCrystal lcd(rs, en, db4, db5, db6, db7);

// LCD geometry
const int LCD_COLS = 16;
const int LCD_ROWS = 2;

// minature digits
uint8_t minidigit[10][8] = {
	{0x07,0x05,0x05,0x05,0x07,0x00,0x00,0x00}, // minature 0
	{0x02,0x06,0x02,0x02,0x07,0x00,0x00,0x00}, // minature 1
	{0x03,0x05,0x02,0x04,0x07,0x00,0x00,0x00}, // minature 2
	{0x07,0x01,0x07,0x01,0x07,0x00,0x00,0x00}, // minature 3
	{0x05,0x05,0x07,0x01,0x01,0x00,0x00,0x00}, // minature 4
	{0x07,0x04,0x06,0x01,0x07,0x00,0x00,0x00}, // minature 5
	{0x07,0x04,0x07,0x05,0x07,0x00,0x00,0x00}, // minature 6
	{0x07,0x01,0x02,0x04,0x04,0x00,0x00,0x00}, // minature 7
	{0x07,0x05,0x07,0x05,0x07,0x00,0x00,0x00}, // minature 8
	{0x07,0x05,0x07,0x01,0x01,0x00,0x00,0x00}, // minature 9
};

void setup()
{

	lcd.begin(LCD_COLS, LCD_ROWS);

	// turn this on to see the custom characters
	// each custom character code will print a tiny number
	// for its code point
#if 0
	for(uint8_t c = 0; c < 8; c++)
		lcd.createChar(c, minidigit[c]);
	lcd.setCursor(0,0);
#endif

	lcd.println("<CR><LF>Test:");

}

void loop(void){}
